'   Understanding angles program
'   Author: Gill. Hayton, Date: November 1988
'
'   Main control routine
    CLS
    SCREEN #1 GRAPHICS 8000 FIXED, 5000 FIXED
    USER #1 SPACE 8000,5000: GRAPHICS MODE 1
    SET #1 MODE 2
    WINDOW OPEN
    WINDOW TITLE "Angles - by Gill Hayton (0628) 23769"
    WINDOW FULL
    OPTION DEGREES
    GRAPHICS WIDTH 3
    RANDOMIZE
    DIM angval (4,2) WORD
    DIM angnam$ (4) FIXED 9
    DIM names$ (4) FIXED 6
    deg$=CHR$(248)
    doneflg=0
    GOSUB initial
    SET COLOUR(2)
LABEL retry
    GOSUB angles
    IF endflag=1 THEN GOTO finish
    GOTO retry

LABEL initial
    SET COLOUR(7)
    BOX 0;0, 8000, 5000 FILL ONLY COLOUR 13
    SHAPE 500;4200, 4000;4800, 7500;4200, 4000;3600 COLOUR 8 FILL ONLY
    PRINT AT (32;4); FONT(3) POINTS(36) COLOUR(1) EFFECTS(1);"ANGLES"
    PRINT AT (30;5); FONT(3) POINTS(36) COLOUR(7) EFFECTS(1);"ANGLES"
    SHAPE 500;2000, 4000;3500, 7500;2000, 4000;500 COLOUR 8 FILL ONLY
    CIRCLE 4200;2200, 1000 FILL COLOUR 1
    PIE 4000;2000, 1000, 0, 60 FILL COLOUR 2
    PIE 4000;2000, 1000, 60, 160 FILL COLOUR 12
    PIE 4000;2000, 1000, 160, 225 FILL COLOUR 14
    PIE 4000;2000, 1000, 225, 315 FILL COLOUR 3
    PIE 4000;2000, 1000, 315, 0 FILL COLOUR 6
    SET COLOUR(15)
    GOSUB wait_key
    angval(1,1) = 0:angval(1,2) = 89
    angval(2,1) = 90:angval(2,2) = 89
    angval(3,1) = 180:angval(3,2) = 179
    angval(4,1) = 89:angval(4,2) = 2
    angnam$(1) = "an acute":angnam$(2) = "an obtuse"
    angnam$(3) = "a reflex":angnam$(4) = "a right"
    names$(1) = "acute":names$(2) = "obtuse"
    names$(3) = "reflex":names$(4) = "right"
    xconv = 8000/XDEVICE:yconv = 5000/YDEVICE
    xconv = XPIXEL:yconv = YPIXEL
    RETURN

LABEL angles
    BOX 0;0,8000,5000 FILL ONLY WITH 8 COLOUR 8
    PRINT AT (30;3) FONT(3) POINTS(24) COLOUR(15) EFFECTS(1);"ANGLES"
    PRINT AT (5;5);"This program demonstrates the measurement of angles in Geometry"
    SET COLOUR(7)
    BOX 1400;2500, 5000, 1200 FILL ONLY COLOUR(15)
    BOX 1200;2300, 5000, 1200 FILL ONLY COLOUR(0)
    BOX 4900;2980,500,250 FILL ONLY COLOUR(6)
    BOX 4900;2500,500,250 FILL ONLY COLOUR(6)
    PRINT AT (14;9);"Do you want definitions?":PRINT AT (51;9);"Yes"
    PRINT AT (14;10);"Click on option box or"
    PRINT AT (14;11);"type Y or N":PRINT AT (51;11);"No"
LABEL ang_def1
    GOSUB wait_press
    IF butt = -1 THEN GOTO ang_def2
    GOSUB calcmse:IF k1=0 THEN GOTO ang_def1
    GOTO ang_def3
LABEL ang_def2
    IF ky$ = "y" OR ky$ = "Y" THEN k1 = 1:GOTO ang_def3
    IF ky$ = "n" OR ky$ = "N" THEN GOTO ang_def3
    ALERT 1 TEXT "No, enter Y or N" BUTTON RETURN "Press return to continue"
    GOTO ang_def1
LABEL ang_def3
    SET COLOUR(2)
    IF k1=1 THEN GOSUB angle_def
    WHILE doneflg = 0
        BOX 0;0,8000,5000 FILL ONLY COLOUR(12)
        BOX 2500;4250,3000,400 FILL ONLY COLOUR(5)
        PRINT AT (30;3); FONT(3) POINTS(18);"Test Options"
        BOX 1200;2300,5000,1400 FILL ONLY COLOUR(5)
        BOX 5000;3430,200,250 FILL ONLY COLOUR(11)
        BOX 5000;2980,200,250 FILL ONLY COLOUR(11)
        BOX 5000;2500,200,250 FILL ONLY COLOUR(11)
        BOX 350;660,6000,500 FILL ONLY COLOUR (5)
        PRINT AT (14;7);"Angle types and sizes":PRINT AT (51;7);"1"
        PRINT AT (14;9);"Make angles":PRINT AT (51;9);"2"
        PRINT AT (14;11);"Quit":PRINT AT (51;11);"3"
        PRINT AT (5;18);"Position the mouse pointer and press the left button"
        PRINT AT (5;19);"or press a number key 1 - 3"
LABEL angles_2
        GOSUB wait_press
        IF butt = -1 THEN GOTO angles_3
        GOSUB calcmouse:IF k1=0 THEN GOTO angles_2
        GOTO angles_4
LABEL angles_3
        k1 = ASC(ky$) - 48
        IF k1 < 1 OR k1 > 3 THEN ALERT 1 TEXT "No, enter 1, 2, or 3" BUTTON RETURN "Press return to continue": GOTO angles_2
LABEL angles_4
        ON k1 GOSUB types,make,done
    WEND
LABEL finish
    CLS
    PRINT AT (5;5);"End of Geometry Program"
    END

LABEL angle_def
    BOX 0;0,8000,4100,FILL ONLY COLOUR 8
    PRINT AT (5;5) COLOUR(12);"An angle is the difference between the directions of two lines"
    GRAPHICS COLOUR 1 STYLE 1
    st = 0
    lnx1=2000:lny1=2000:lnx2=4000:lny2=2000
    ang=45:bckgnd=8:n1=3:lngth=lnx2-lnx1
    GOSUB draw_angle
    PRINT AT (44;14);"Line 1"
    PRINT AT (37;7);"Line 2"
    PRINT AT (15;16);"Angle"
    LINE 2000;1500, 2200;2100
    GOSUB wait_key
    BOX 0;0,8000,4100 FILL ONLY WITH 8 COLOUR 8
    PRINT AT (5;5) COLOUR (12);"If the difference in direction is a complete circle the angle is 360";deg$
    lnx1=3000:lny1=2000:lnx2=4500:lny2=2000
    ang=361:n1=24:lngth=lnx2-lnx1
    GOSUB draw_angle
    PRINT AT (50;13);"Line 2"
    PRINT AT (50;14);"Line 1"
    PRINT AT (15;17);"Angle 360";deg$
    LINE 2000;1400, 2900;1900
    PRINT AT (5;18) COLOUR(12);"360 seems a strange number to choose but the Ancient Babylonians"
    PRINT AT (5;19) COLOUR(12);"liked it because so many numbers can be divided into it"
    GOSUB wait_key
    BOX 0;0,8000,4100 FILL ONLY WITH 8 COLOUR 8
    PRINT AT (5;5) COLOUR (12);"If the the angle is 180";deg$;" (half of 360";deg$;") you get a straight line"
    lnx1=3000:lny1=2000:lnx2=4500:lny2=2000
    ang=181:n1=12:lngth=lnx2-lnx1
    GOSUB draw_angle
    PRINT AT (10;13);"Line 2"
    PRINT AT (50;14);"Line 1"
    PRINT AT (15;17);"Angle 180";deg$
    LINE 2000;1400, 2900;2100
    GOSUB wait_key
    BOX 0;0,8000,4100 FILL ONLY WITH 8 COLOUR 8
    PRINT AT (5;5) COLOUR(12);"Special angle names:"
    lnx1=1600:lny1=3000:lnx2=2300:lny2=3000
    ang=91:n1=6:lngth=lnx2-lnx1
    GOSUB draw_angle
    PRINT AT (24;7);"Right Angle"
    PRINT AT (7;11) COLOUR(12);"Angle = 90";deg$
    lnx1=4360:lnx2=5060
    ang=61:n1=4
    GOSUB draw_angle
    PRINT AT (52;7);"Acute Angle"
    PRINT AT (40;11) COLOUR(12);"Angle less than 90";deg$
    lnx1=1600:lny1=1750:lnx2=2300:lny2=1750
    ang=136:n1=15
    GOSUB draw_angle
    PRINT AT (20;13);"Obtuse Angle"
    PRINT AT (7;17) COLOUR(12);"Angle between 90";deg$;" and 180";deg$
    lnx1=4360:lnx2=5060
    ang=226:n1=15
    GOSUB draw_angle
    PRINT AT (52;13);"Reflex Angle"
    PRINT AT (45;17) COLOUR(12);"Angle greater than 180";deg$
    LINE 1500;2500, 1700;3100
    LINE 4260;2500, 4460;3100
    LINE 1500;1250, 1700;1850
    LINE 4360;1250, 4460;1850
    GOSUB wait_key
LABEL angles2
    RETURN

LABEL types
    quest=0:corr=0:incorr=0
    bckgnd=8
LABEL types_1
    BOX 0;0, 8000,5000 FILL ONLY COLOUR 8
    PRINT AT (25;2) COLOUR(7) FONT(2) POINTS(16); "Angle types and sizes"
    PRINT AT (5;4) COLOUR(12);"I shall draw an angle on the screen and then ask which type and"
    PRINT AT (5;5) COLOUR(12);"how big it is. I shall accept answers that are correct to within 10";deg$
    na = RND(4)
    IF na=4 THEN testang = 90:GOTO types_2
    numb = angval(na,2)
    testang=RND(numb) + angval(na,1)
LABEL types_2
    maxang = 360 - testang
    startang = RND(maxang)
    lngth = RND(1000) + 500
    lnx1=3000:lny1=2500
    lnx2=INT(lngth*COS(startang))+3000:lny2=INT(lngth*SIN(startang))+2500
    st = startang:ang=testang+1
    n1 = INT(testang/15)
    IF n1 < 1 THEN n1=1
    GOSUB draw_angle
    BOX 3100;940,690,250 FILL ONLY COLOUR(6)
    SET COLOUR (12)
    INPUT AT (5;18);"What type of angle is this";ans$
    SET COLOUR (2)
    ans$ = LOWER$(ans$)
    IF ans$=names$(na) THEN corr=corr+1:PRINT AT (43;18);"That's right - good":GOTO types_3
    incorr=incorr+1:PRINT AT (43;18);"No, it is ";angnam$(na);" angle"
LABEL types_3
    BOX 4000;720,350,260 FILL ONLY COLOUR(6)
    SET COLOUR (12)
    INPUT AT (5;19);"Can you guess the size of the angle";numb
    SET COLOUR (2)
    IF numb = testang THEN corr=corr+1:PRINT AT (5;20);"Well done - you are exactly right":GOTO types_5
    IF testang-11<numb AND numb<testang+11 AND numb>angval(na,1) AND numb<(angval(na,1)+angval(na,2)) THEN GOTO types_4
    incorr = incorr + 1:PRINT AT (5;20);"No - the angle is ";testang;deg$
    GOTO types_5
LABEL types_4
    corr=corr+1:PRINT AT (5;20);"Near enough - the angle is actually ";testang;deg$
LABEL types_5
    GOSUB set_prompt
    IF try_flag = 0 THEN GOTO types_1
    IF try_flag = 1 THEN RETURN
    RETURN

LABEL make
    quest=0:corr=0:incorr=0
    bckgnd=8
LABEL make_1
    BOX 0;0, 8000,5000 FILL ONLY COLOUR 8
    PRINT AT (25;2) COLOUR(7) FONT(2) POINTS(16); "Make Angles"
    n1 = 4: quest = quest + 1: IF quest  > 2 THEN GOTO make_1a
    PRINT AT (5;n1) COLOUR(12);"I shall draw the first line of an angle and say what size angle I want"
    PRINT AT (5;n1+1) COLOUR(12);"You must put in the 2nd line. Move the mouse pointer to a good"
    PRINT AT (5;n1+2) COLOUR(12);"position on the screen and press the left button until the 2nd line"
    PRINT AT (5;n1+3) COLOUR(12);"of the angle is drawn to that point. Move the mouse to adjust the"
    PRINT AT (5;n1+4) COLOUR(12);"angle until you think it is right then press the left button again.":n1 = n1 + 5
LABEL make_1a
    na = RND(4)
    IF na=4 THEN testang = 90:GOTO make_2
    numb = angval(na,2)
    testang=RND(numb) + angval(na,1)
LABEL make_2
    PRINT AT (5;n1);"Make an angle of";testang;deg$
    lngth = RND(1000) + 500
    lnx1=2000:lny1=1800
    lnx2=lnx1+lngth:lny2=lny1
    LINE lnx1;lny1, lnx2;lny2
LABEL make_2a
    REPEAT
        butt = BUTTON(1)
        ky2 = INKEY
    UNTIL butt > -1 OR ky2 = 13
    x1 = CINT(XMOUSE*xconv):y1 = CINT(YMOUSE*yconv)
    IF x1 > 8000 OR y1 > 5000 OR x1 < 1 OR y1 < 1 THEN GOTO make_2a
    LINE lnx1;lny1, x1;y1
    butt = 0
    x2 = x1:y2 = y1
    FOR pause = 1 TO 2000:NEXT pause
    REPEAT
        FOR pause = 1 TO 500:NEXT pause
LABEL make_2b
        x1 = INT(XMOUSE*xconv):y1 = INT(YMOUSE*yconv)
        IF x1 > 8000 OR y1 > 5000 OR x1 < 1 OR y1 < 1 THEN GOTO make_2b
        LINE lnx1;lny1, x2;y2 COLOUR bckgnd
        LINE lnx1;lny1, x1;y1
        x2 = x1:y2 = y1
        butt1 = BUTTON(1):IF butt1 > -1 THEN butt = 1
        ky2 = INKEY: IF ky2 = 13 THEN butt = 1
    UNTIL butt=1
    deg1 = ATAN2((x1-lnx1),(y1-lny1))
    deg1 = INT(deg1)
    IF deg1 < 0 THEN deg1 = 360 + deg1
    acrpt = INT(lngth/2)
    st = 0: ang = deg1: n1 = INT(deg1/15)
    IF n1 < 1 THEN n1 = 1
    PIE lnx1;lny1,acrpt,0,deg1 FILL COLOUR 3
    LINE lnx1;lny1, lnx2;lny2
    LINE lnx1;lny1, x1;y1
    CIRCLE lnx1;lny1,acrpt PART 0,deg1 END 1
    a1 = MAX(testang,deg1):a2 = MIN(testang,deg1)
    IF (a1-a2) < 11 THEN PRINT AT (5;20);"Well done, you have drawn an angle of";deg1;deg$:corr=corr+1:GOTO make_3
    PRINT AT (5;20);"You have drawn an angle of";deg1;deg$:incorr=incorr+1
    PRINT AT (40;20) COLOUR(12);"Here is what it should be"
LABEL make_3
    IF (a1-a2) < 6 THEN GOTO make_4
    ang = testang+1
    lnx1 = 5000: lnx2= 5000+lngth
    n1 = testang
    IF n1 < 1 THEN n1=1
    GOSUB draw_angle
    PRINT AT (65;14) COLOUR(12);"This is";testang;deg$
LABEL make_4
    GOSUB set_prompt
    IF try_flag = 0 THEN GOTO make_1
    IF try_flag = 1 THEN RETURN
    RETURN

LABEL wait_press
    REPEAT
        butt = BUTTON(1)
        ky$ = INKEY$
    UNTIL butt > -1 OR ky$ <> ""
    RETURN

LABEL done
REM Set flag to show user wishes to quit
    doneflg = 1
    RETURN

LABEL draw_angle
    LINE lnx1;lny1, lnx2;lny2
    acrpt=INT((lngth)/2)
    FOR i = 1 TO ang STEP n1
        x1=CINT(lnx1+(lngth*COS(st+i)))
        y1=CINT(lny1+(lngth*SIN(st+i)))
        LINE lnx1;lny1, x1;y1 WIDTH 3
        IF i > (n1+1) THEN LINE lnx1;lny1, x2;y2 COLOUR bckgnd
        IF i < 3 THEN GOTO draw_1
        CIRCLE lnx1;lny1, acrpt, PART st,st+i-1
LABEL draw_1
        IF i = ang THEN GOTO draw_2
        x2=x1:y2=y1
        CIRCLE lnx1;lny2, acrpt PART st,st+i-1 COLOUR bckgnd
LABEL draw_2
    NEXT i
    x1=CINT(lnx1+(lngth*COS(st+ang)))
    y1=CINT(lny1+(lngth*SIN(st+ang)))
    LINE lnx1;lny1, x2;y2 COLOUR bckgnd
    PIE lnx1;lny1,acrpt,st,st+ang-2 FILL COLOUR 3
    LINE lnx1;lny1, lnx2;lny2
    LINE lnx1;lny1, x1;y1
    CIRCLE lnx1;lny1, acrpt, PART st,st+ang-2 END 1
    RETURN

LABEL wait_key
    PRINT AT (10;21);"Press any key to continue"
    REPEAT
        ky$=INKEY$
        butt = BUTTON(1)
    UNTIL ky$<>"" OR butt > -1
    RETURN

LABEL set_prompt
    PRINT AT (50;9);"Score:";corr;"right out of";(incorr+corr)
LABEL set_pr2
    PRINT AT (5;21);"Enter C to continue, E to end the test, or Q to quit the program"
    REPEAT
        ky$ = INKEY$
    UNTIL ky$ <> ""
    IF ky$ = "c" OR ky$ = "C" THEN try_flag = 0:GOTO set_pr3
    IF ky$ = "e" OR ky$ = "E" THEN try_flag = 1:GOTO set_pr3
    IF ky$ = "q" OR ky$ = "Q" THEN GOTO finish
    ALERT 1 TEXT "No, enter C, E, or Q" BUTTON RETURN "Press return to continue"
    GOTO set_pr2
LABEL set_pr3
    RETURN

LABEL calcmse
    k1 = 0
    x1 = INT(XMOUSE * xconv):y1 = INT(YMOUSE * yconv)
    IF x1 < 4800 OR x1 > 5600 OR y1 < 2400 THEN GOTO calc_1
    IF y1 < 2800 THEN k1 = 2:GOTO calc_1
    IF y1 < 2900 THEN GOTO calc_1
    IF y1 < 3290 THEN k1 = 1
LABEL calc_1
    RETURN


LABEL calcmouse
    k1 = 0
    x1 = INT(XMOUSE * xconv):y1 = INT(YMOUSE * yconv)
    IF x1 < 4900 OR x1 > 5300 OR y1 < 2400 THEN GOTO calc_2
    IF y1 < 2800 THEN k1 = 3:GOTO calc_2
    IF y1 < 2900 THEN GOTO calc_2
    IF y1 < 3290 THEN k1 = 2:GOTO calc_2
    IF y1 < 3380 THEN GOTO calc_2
    IF y1 < 3730 THEN k1 = 1
LABEL calc_2
    RETURN

